## @package ardi.api.assets
#  ARDI Asset API
#
#  These classes allow you to interrogate and modify assets.
import pycurl
import urllib
import xmltodict
try:
    from io import BytesIO
except ImportError:
    from StringIO import StringIO as BytesIO
import datetime

## Represents a single ARDI asset
#
#  This class represents a single ARDI asset
#
#  @todo This class is a placeholder and has little-to-no functionality as yet.
class ARDIHistory:
    def __init__(self, core):
        self.core = core
        self.id = id

    def GetSamples(self,points,starttime, endtime, grain):
        resp = []

        sd = starttime.strftime("%Y-%m-%d %H:%M:%S")
        ed = endtime.strftime("%Y-%m-%d %H:%M:%S")

        xml = self.core.APICall("api/gethistorybulk",{ 'points' : '_'.join(points), 'start' : sd,'end' : ed,'grain': grain,'format': 'tdle' })
        if xml == False:
            return False

        bits = xml.split("\r\n")
        for b in bits:
            ss = b.split(",")
            #print(str(ss))
            try:
                g = []
                g.append(points[int(ss[1])])
                g.append(datetime.datetime.utcfromtimestamp(int(ss[0])))
                g.append(','.join(ss[2:]))
                         
                resp.append(g)
            except:
                pass
        return resp

    
